=== debian/changelog ===
ros-bouncy-rclcpp (0.5.1-0bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Dirk Thomas <dthomas@osrfoundation.org>  Thu, 28 Jun 2018 23:37:37 -0000

ros-bouncy-rclcpp (0.5.0-0bionic) bionic; urgency=high

  * Fixed a bug in the multi-threaded executor which could cause it to take a timer (potentially other types of wait-able items) more than once to be worked one. (#383 <https://github.com/ros2/rclcpp/issues/383>)
    * Specifically this could result in a timer getting called more often that it should when using the multi-threaded executor.
  * Added functions that allow you to publish serialized messages and received serialized messages in your subscription callback. (#388 <https://github.com/ros2/rclcpp/issues/388>)
  * Changed code to always get the Service name from ``rcl`` to ensure the remapped name is returned. (#498 <https://github.com/ros2/rclcpp/issues/498>)
  * Added previously missing ``set_parameters_atomically()`` method to the Service client interface. (#494 <https://github.com/ros2/rclcpp/issues/494>)
  * Added ability to initialize parameter values in a Node via a YAML file passed on the command line. (#488 <https://github.com/ros2/rclcpp/issues/488>)
  * Fixed the ROS parameter interface which got parameters that aren't set. (#493 <https://github.com/ros2/rclcpp/issues/493>)
  * Added ability to initialize parameter values in a node with an argument to the Node constructor. (#486 <https://github.com/ros2/rclcpp/issues/486>)
  * Added a ``Subscription`` tests which uses ``std::bind`` to a class member callback. (#480 <https://github.com/ros2/rclcpp/issues/480>)
  * Refactored the ``ParameterVariant`` class into the ``Parameter`` and ``ParameterValue`` classes. (#481 <https://github.com/ros2/rclcpp/issues/481>)
  * Relaxed template matching rules for ``std::bind`` and ``GNU C++ >= 7.1``. (#484 <https://github.com/ros2/rclcpp/issues/484>)
  * Changed to use the new ``rosgraph_msgs/Clock`` message type for the ``/clock`` topic. (#474 <https://github.com/ros2/rclcpp/issues/474>)
  * Fixed a flaky ROS time test due to not spinning before getting the time. (#483 <https://github.com/ros2/rclcpp/issues/483>)
  * Nodes now autostart the ROS parameter services which let you get, set, and list parameters in a node. (#478 <https://github.com/ros2/rclcpp/issues/478>)
  * Added support for arrays in Parameters. (#443 <https://github.com/ros2/rclcpp/issues/443>)
  * Changed how executors use ``AnyExecutable`` objects so that they are a reference instead of a shared pointer, in order to avoid memory allocation in the "common case". (#463 <https://github.com/ros2/rclcpp/issues/463>)
  * Added ability to pass command line arguments to the Node constructor. (#461 <https://github.com/ros2/rclcpp/issues/461>)
  * Added an argument to specify the number of threads a multithreaded executor should create. (#442 <https://github.com/ros2/rclcpp/issues/442>)
  * Changed library export order for static linking. (#446 <https://github.com/ros2/rclcpp/issues/446>)
  * Fixed some typos in the time unit tests. (#453 <https://github.com/ros2/rclcpp/issues/453>)
    Obviously it mean RCL_SYSTEM_TIME but not RCL_ROS_TIME in some test cases
    * Signed-off-by: jwang <mailto:jing.j.wang@intel.com>
  * Added the scale operation to ``rclcpp::Duration``.
    * Signed-off-by: jwang <mailto:jing.j.wang@intel.com>
  * Changed API of the log location parameter to be ``const``. (#451 <https://github.com/ros2/rclcpp/issues/451>)
  * Changed how the subscriber, client, service, and timer handles are stored to resolve shutdown order issues. (#431 <https://github.com/ros2/rclcpp/issues/431> and #448 <https://github.com/ros2/rclcpp/issues/448>)
  * Updated to get the node's logger name from ``rcl``. (#433 <https://github.com/ros2/rclcpp/issues/433>)
  * Now depends on ``ament_cmake_ros``. (#444 <https://github.com/ros2/rclcpp/issues/444>)
  * Updaed code to use logging macros rather than ``fprintf()``. (#439 <https://github.com/ros2/rclcpp/issues/439>)
  * Fixed a bug that was using an invalid iterator when erasing items using an iterator in a loop. (#436 <https://github.com/ros2/rclcpp/issues/436>)
  * Changed code to support move of ``rcutils_time_point_value_t`` type from ``uint64_t`` to ``int64_t``. (#429 <https://github.com/ros2/rclcpp/issues/429>)
  * Renamed parameter byte type to ``byte_values`` from ``bytes_value``. (#428 <https://github.com/ros2/rclcpp/issues/428>)
  * Changed executor code to clear the wait set before resizing and waiting. (#427 <https://github.com/ros2/rclcpp/issues/427>)
  * Fixed a potential dereference of nullptr in the topic name validation error string. (#405 <https://github.com/ros2/rclcpp/issues/405>)
    * Signed-off-by: Ethan Gao <mailto:ethan.gao@linux.intel.com>
  * Changed to use ``rcl_count_publishers()`` like API's rather than the lower level ``rmw_count_publishers()`` API. (#425 <https://github.com/ros2/rclcpp/issues/425>)
    * Signed-off-by: Sriram Raghunathan <mailto:rsriram7@visteon.com>
  * Fix potential segmentation fault due to ``get_topic_name()`` or ``rcl_service_get_service_name()`` returning nullptr and that not being checked before access in ``rclcpp``. (#426 <https://github.com/ros2/rclcpp/issues/426>)
    * Signed-off-by: Ethan Gao <mailto:ethan.gao@linux.intel.com>
  * Contributors: Denise Eng, Dirk Thomas, Ernesto Corbellini, Esteve Fernandez, Ethan Gao, Guillaume Autran, Karsten Knese, Matthew, Michael Carroll, Mikael Arguedas, Shane Loretz, Sriram Raghunathan, Tom Moore, William Woodall, dhood, jwang, jwang11, serge-nikulin

 -- Dirk Thomas <dthomas@osrfoundation.org>  Mon, 25 Jun 2018 07:00:00 -0000
